Ext.namespace('dSS11', 'dSS11.data');

dSS11.data.PackageStore = Ext.extend(Ext.data.Store,
    {
        constructor: function(config) {
            var rec = Ext.data.Record.create(
            [
                {
                    name: 'name'
                },
                {
                    name: 'version'
                },
                {
                    name: 'maintainer'
                },
                {
                    name: 'description'
                },
                {
                    name: 'homepage'
                },
                {
                    name: 'state'
                },
                {
                    name: 'tags',
                },
                {
                    name: 'hrname'
                }
            ]);

            var rdr = new Ext.data.JsonReader({ root: 'data' }, rec);

            Ext.apply(this, {
                reader: rdr,
                url: config.url
            });

            dSS11.data.PackageStore.superclass.constructor.call(this, arguments);
            this.on('load', function(store, records, options) {
                    Ext.each(records, function(record) {
                        var params = Ext.urlDecode(record.get('tags'));
                        if (params.name !== undefined) {
                            record.set('hrname', params.name);
                        } else {
                            record.set('hrname', record.get('name'));
                        }
                        record.commit();
                    });
                },
                this);
        }
    }
);

dSS11.data.LoaderImpl = Ext.extend(Ext.util.Observable, {
    constructor: function() {
        this.AddOnsUpdateStore = new dSS11.data.PackageStore({
                url: '/cgi-bin/opkgwrapper.sh?action=addon-list-upgradable' });
        this.AddOnsFeedPackagesStore = new dSS11.data.PackageStore({
                url: '/cgi-bin/opkgwrapper.sh?action=addon-list' });
    },
    getAddOnsUpdateStore: function() {
        return this.AddOnsUpdateStore;
    },
    getAddOnsFeedPackagesStore: function() {
        return this.AddOnsFeedPackagesStore;
    }
});

dSS11.data.Loader = (function() {
    return new dSS11.data.LoaderImpl();
})();

